
Main = class();

-- Initializes a new Main instance
function Main:Constructor()
    local filterData = FilterData();
	local filterEngine = FilterEngine(filterData);
	local shellCommandHandler = ShellCommandHandler(filterEngine);

	self.SpamFilter = SpamFilter(filterEngine);
	self.OptionsPanel = UI.Views.OptionsPanel(UI.ViewModels.OptionsViewModel(filterEngine));
	self.ShellCommand = ShellCommand(shellCommandHandler);
end

-- Called when the plugin is loading
function Main:OnLoad()
	if self.ShellCommand:RegisterCommandName("spam") ~= true then
		local uniqueName = string.lower(plugin:GetAuthor() .. "." .. plugin:GetName() .. "." .. plugin:GetVersion());
		self.ShellCommand:RegisterCommandName(uniqueName);
	end	

	Settings:Load();
end

-- Called when the plugin is unloading
function Main:OnUnload()
	Settings:Save();
	self.ShellCommand:UnregisterCommandName();
end

-- Called for every incoming chat message
function Main:OnChatMessage(message, chatType)
	self.SpamFilter:HandleMessage(message, chatType);
end

-- Called to display the options panel
function Main:GetOptionsPanel()
	return self.OptionsPanel;
end
